#include <avr/io.h>
#include "lcd.h"
#include "keyb.h"

void blink();
void countdown(int s);

int main(void)
{
	lcdInit();
	lcdInitPrintf();
	keybInit();
	TCCR1B = _BV(WGM12) | _BV(CS11) | _BV(CS10);
	DDRB = _BV(DDB0);
	while (1) {
		lcdWriteCommand(LCD_COMMAND_ON_OFF | LCD_PARAM_ON_OFF_DISPLAY | LCD_PARAM_ON_OFF_CURSOR);
		lcdGotoXY(0, 0);
		int s = readNumber();
		lcdWriteCommand(LCD_COMMAND_ON_OFF | LCD_PARAM_ON_OFF_DISPLAY);
		lcdGotoXY(0, 0);
		printf("%3u", s);
		countdown(s);
		blink();
	}
}

void countdown(int s) {
	OCR1A = 15624;
	TIFR |= _BV(OCF1A);
	while(s != 0) {
		while(!(TIFR & _BV(OCF1A)));
		TIFR |= _BV(OCF1A);
		s--;
		lcdGotoXY(0, 0);
		printf("%3u", s);
	}
}

void blink() {
	OCR1A = 1562;
	while (readKeyboard() == 0) {
		while(!(TIFR & _BV(OCF1A)));
		TIFR |= _BV(OCF1A);
		PORTB = _BV(PB0);
		while(!(TIFR & _BV(OCF1A)));
		TIFR |= _BV(OCF1A);
		PORTB = 0;
	}
	while (readKeyboard() != 0);
}